<?php

namespace Ig\IgNewsletter\Controller;

use TYPO3\CMS\Core\Context\Context;
use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Core\Database\ConnectionPool;
use TYPO3\CMS\Core\Database\Query\Restriction\DeletedRestriction;
use TYPO3\CMS\Extbase\Mvc\Controller\ActionController;

class ContentController extends ActionController {

    private $queryBuilder;

    protected function initializeAction() {
      //die('wird ausgefühlrt bahjashdfjkawhefil');
      $connection = GeneralUtility::makeInstance(ConnectionPool::class)->getConnectionForTable('tt_content');
      $this->queryBuilder = $connection->createQueryBuilder();

    }

    /**
     *
     * @return string   	asdf
     */
    public function showAction() {
      //die('wird ausgefühlrt bahjashdfjkawhefil');
        /** @var \TYPO3\CMS\Frontend\Controller\TypoScriptFrontendController */
        $fe = $GLOBALS['TSFE'];
        $pid = $fe->id;
        $headerLinks = $this->getContentHeaderLinks($pid);
        // exit;
        $this->view->assign('headerLinks', $headerLinks);
    }
    private function getContentByPid($pid, $container=0) {
        $context = GeneralUtility::makeInstance(Context::class);
        $languageId = $context->getPropertyFromAspect('language', 'id');
        $this->queryBuilder->select('*')
                           ->from( 'tt_content' )
                           ->where(
                               $this->queryBuilder->expr()->eq('pid', $this->queryBuilder->createNamedParameter($pid, \PDO::PARAM_INT)),
                               $this->queryBuilder->expr()->eq('tx_gridelements_container', $this->queryBuilder->createNamedParameter($container, \PDO::PARAM_INT)),
                               $this->queryBuilder->expr()->neq('goToTop', 1),
                               $this->queryBuilder->expr()->neq('header_layout', 100),
                               // @todo overlays
                               $this->queryBuilder->expr()->orX(
                                   $this->queryBuilder->expr()->eq('sys_language_uid', -1),
                                   $this->queryBuilder->expr()->eq('sys_language_uid', (int) $languageId)              
                               )
                           );
        $this->queryBuilder->orderBy($GLOBALS['TCA']['tt_content']['ctrl']['sortby']);
        $result = $this->queryBuilder->execute();
        return $result->fetchAll();
    }


    private function getContentHeaderLinks($pid) {
      $rows=$this->getContentByPid( $pid );

      return '<ul class="igcontenttopics-ul">'.$this->getContentHeaderLinksByRows($rows, 0).'</ul>';
    }

    private function getContentHeaderLinksByRows($rows ,$deep = 0) {
        $result = '';
        $li_is_open = false;

//        var_dump($rows);

        foreach ($rows as $row) {
            if (trim($row['header']) != '') {
                $result.= ($li_is_open ? '</li>' : '') . '<li class="contenttopics-li"><a class="contenttopics-link" href="#c' . $row['uid'] . '">' . $row['header'] . '</a>';    
                    $li_is_open=true;

            }
	    $children=$this->getContentByPid( $row['pid'], $row['uid'] );
	    //echo('<h2>'. $row['uid'].'</h2>');var_dump($children);
            if (count($children)>0) {
                    if ( !$li_is_open ) {
                            $result .= $this->getContentHeaderLinksByRows($children);
                    }    else {
                    $result .= ($li_is_open ? '' : '<li class="contenttopics-li">') .'<ul style="margin-left:25px;">' . $this->getContentHeaderLinksByRows($children) . '</ul></li>';
                    }
               $li_is_open=false;
            }
        }
        return $result . ($li_is_open ? '</li>' : '');
    }

}

?>
